<template>
  <a-page-header :title="getPageTitle()" @back="() => $router.go(-1)">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="id"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'image'">
              <a-image :src="record.image" :width="50" />
            </template>
            <template v-if="column.key === 'storeName'">
              <a-tag v-if="record.storeName" color="orange">{{ record.storeName }}</a-tag>
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">显示</a-tag>
              <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openEdit(record)">修改</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <ShopStoreRiderEdit v-model:visible="showEdit" :data="current" @done="reload" />
  </a-page-header>
</template>

<script lang="ts" setup>
  import { createVNode, ref, computed } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import {getPageTitle} from '@/utils/common';
  import ShopStoreRiderEdit from './components/shopStoreRiderEdit.vue';
  import { pageShopStoreRider, removeShopStoreRider, removeBatchShopStoreRider } from '@/api/shop/shopStoreRider';
  import type { ShopStoreRider, ShopStoreRiderParam } from '@/api/shop/shopStoreRider/model';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<ShopStoreRider[]>([]);
  // 当前编辑数据
  const current = ref<ShopStoreRider | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageShopStoreRider({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 完整的列配置（包含所有字段）
  const columns = ref<ColumnItem[]>([
    {
      title: '用户ID',
      dataIndex: 'userId',
      key: 'userId',
      width: 90
    },
    {
      title: '所属门店',
      dataIndex: 'storeName',
      key: 'storeName'
    },
    {
      title: '配送员',
      dataIndex: 'realName',
      key: 'realName'
    },
    {
      title: '手机号',
      dataIndex: 'mobile',
      key: 'mobile'
    },
    // {
    //   title: '头像',
    //   dataIndex: 'avatar',
    //   key: 'avatar'
    // },
    {
      title: '身份证号',
      dataIndex: 'idCardNo',
      key: 'idCardNo'
    },
    // {
    //   title: '状态',
    //   dataIndex: 'status',
    //   key: 'status',
    //   align: 'center'
    // },
    {
      title: '接单状态',
      dataIndex: 'workStatus',
      key: 'workStatus',
      align: 'center'
    },
    {
      title: '自动派单',
      dataIndex: 'autoDispatchEnabled',
      key: 'autoDispatchEnabled',
      align: 'center'
    },
    {
      title: '派单优先级',
      dataIndex: 'dispatchPriority',
      key: 'dispatchPriority',
      width: 90,
      align: 'center'
    },
    // {
    //   title: '最大同时配送单数（0表示不限制）',
    //   dataIndex: 'maxOnhandOrders',
    //   key: 'maxOnhandOrders',
    //   width: 120
    // },
    // {
    //   title: '是否计算工资',
    //   dataIndex: 'commissionCalcEnabled',
    //   key: 'commissionCalcEnabled',
    //   width: 90
    // },
    // {
    //   title: '水每桶提成金额（元/桶）',
    //   dataIndex: 'waterBucketUnitFee',
    //   key: 'waterBucketUnitFee'
    // },
    // {
    //   title: '商品提成方式',
    //   dataIndex: 'otherGoodsCommissionType',
    //   key: 'otherGoodsCommissionType'
    // },
    // {
    //   title: '其他商品提成值：固定金额(元)或比例(%)',
    //   dataIndex: 'otherGoodsCommissionValue',
    //   key: 'otherGoodsCommissionValue'
    // },
    // {
    //   title: '备注',
    //   dataIndex: 'comments',
    //   key: 'comments',
    //   ellipsis: true
    // },
    // {
    //   title: '排序号',
    //   dataIndex: 'sortNumber',
    //   key: 'sortNumber',
    //   width: 120
    // },
    {
      title: '创建时间',
      dataIndex: 'createTime',
      key: 'createTime',
      width: 200,
      align: 'center',
      sorter: true,
      ellipsis: true,
      customRender: ({ text }) => toDateString(text, 'yyyy-MM-dd HH:mm:ss')
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: ShopStoreRiderParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: ShopStoreRider) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: ShopStoreRider) => {
    const hide = message.loading('请求中..', 0);
    removeShopStoreRider(row.id)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchShopStoreRider(selection.value.map((d) => d.id))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: ShopStoreRider) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
  query();
</script>

<script lang="ts">
  export default {
    name: 'ShopStoreRider'
  };
</script>

<style lang="less" scoped></style>
